﻿using AutoMapper;
using Correo.Application.CommandHandlers;
using Correo.PublishedLanguage.Commands;
using MediatR;
using Microsoft.AspNetCore.Mvc;
using System.Threading.Tasks;

namespace Correo.Controllers
{
    [ApiController]
    [Route("api/mailer")]
    public class MailerController : ControllerBase
    {
        private readonly IMediator _mediator;
        private readonly IMapper _mapper;

        public MailerController(IMediator mediator, IMapper mapper)
        {
            _mediator=mediator;
            _mapper=mapper;
        }

        [HttpPost("email")]
        public async Task<IActionResult> SendEmail([FromBody] SendEmail sendEmail)
        {
            var command = _mapper.Map<SendEmailHandlerSync.Command>(sendEmail);
            var result = await _mediator.Send(command);
            return Ok(result);
        }
    }
}
