﻿using Microsoft.Extensions.Logging;
using System.Threading.Tasks;
using System.Threading;
using System;
using NBB.Messaging.Abstractions;
using NBB.Core.Pipeline;

namespace Correo.Middlewares
{
    public class SubscriberLoggingMiddleware : IPipelineMiddleware<MessagingContext>
    {
        private readonly ILogger<SubscriberLoggingMiddleware> _logger;

        public SubscriberLoggingMiddleware(ILogger<SubscriberLoggingMiddleware> logger)
        {
            _logger = logger;
        }

        public async Task Invoke(MessagingContext ctx, CancellationToken cancellationToken, Func<Task> next)
        {
            _logger.LogDebug("Message {@Message} was received.", ctx.MessagingEnvelope.Payload);
            await next();
        }
    }
}
